#-*- encoding: utf-8 -*-
require 'curses'

def secto(s)
	r = {h: 0,m: 0,s: 0}
	loop do
		if s < 60 then
			r[:s] = s
			break
		end
		s = s - 60
		r[:m] += 1
	end

	loop do
		if r[:m] < 60 then
			break
		end
		r[:m] -= 60
		r[:h] += 1
	end
	return r
end

def getCount()
	ti = STDIN.gets	
	if ti[0] !~ /\d/ then
		raise("User input is invalid.")
	end

	ks = String.new
	hms = {ho: false,mi: false,se: false}
	counttime = 0
	0.upto(ti.size - 1) do |x|
		if ti[x] =~ /\d/ then
			ks.concat(ti[x])
		else
			if ti[x] =~ /[Hh]/  and hms[:ho] == false then
				counttime += ks.to_i * 60 * 60
				hms[:ho] = true
				ks = ""
			elsif ti[x] =~ /[Hh]/ and hms[:ho] == true then
				raise("User input is invalid.")
			end

			if ti[x] =~ /[Mm]/  and hms[:mi] == false then
				counttime += ks.to_i * 60
				hms[:mi] = true
				ks = ""
			elsif ti[x] =~ /[Mm]/  and hms[:mi] == true then
				raise("User input is invalid.")
			end

			if ti[x] =~ /[Ss]/ and hms[:se] == false then
				counttime += ks.to_i
				hms[:se] = true
				ks = ""
			elsif ti[x] =~ /[Ss]/ and hms[:se] == true then
				raise("User input is invalid.")
			end
		end
	end
	if hms[:ho] == false and hms[:mi] == false and hms[:se] == false then
		raise("User input is invalid.")
	end
	return counttime
end




class CursesCounter
	def initialize(countup,counttime)
		if countup == true or countup == false then
			@countup = countup
		else
			raise(ArgumentError,"CursesCounter::initialize argument error.")
		end

		if countup == false then
			@countt = counttime
		else
			@countt = 0
		end
		Curses::init_screen
		Curses::setpos(0,0)
		if countup == true then
			Curses::addstr("Count UP")
		else
			Curses::addstr("Count Down")
		end
		Curses::refresh
	end

	def start()
		Curses::noecho
		Curses::noraw
		Curses::crmode
		Curses::setpos(1,0)
		Curses::addstr("Please any key to start.")
		Curses::refresh
		Curses::getch
		Curses::deleteln
		Curses::refresh
		self.timer
	end

	def timer()
		Curses::standout
		Curses::noraw

		if @countup == true then
			self.cup()
		else
			self.cdown()
		end
		Curses::beep
		Curses::beep
		Curses::flash
	end
	protected :timer

	def cup_exit()
		Curses::close_screen()
		print "TOTAL = " + @countt.to_s + "[s]\n"
		h = secto(@countt)
		print h[:h].to_s + "[h] " + h[:m].to_s + "[m] " + h[:s].to_s + "[s]\n"
		exit 0
	end
	protected :cup_exit

	def cup()
		Curses::setpos(Curses::lines / 2,Curses::cols / 2)
		Signal.trap(:INT){Curses::setpos(Curses::lines,0);Curses::addstr("STOP!!");sleep(1);cup_exit()}
		Signal.trap(:TERM){}
		Signal.trap(:HUP){}
		s,m,h = 0,0,0
		loop do
			Curses::setpos((Curses::lines / 2) + 1,Curses::cols / 2)
			if s % 60 == 0  and s != 0 then
				s = 0
				m += 1
			end	
			if m % 60 == 0 and m != 0 then
				m = 0
				h += 1
			end
			Curses::deleteln
			Curses::addstr(h.to_s + " : " + m.to_s + " : " + s.to_s + " || " + @countt.to_s)
			@countt += 1
			s += 1
			Curses::refresh
			sleep 1
		end
	end
	protected :cup


	def cdown()
		Signal.trap(:INT){exit(0)}
		Signal.trap(:TERM){}
		Signal.trap(:HUP){}
		r = secto(@countt)
		@countt.downto(0) do |x|
			Curses::setpos((Curses::lines / 2) + 1,Curses::cols / 2)
			Curses::deleteln
			Curses::addstr(r[:h].to_s + ":" + r[:m].to_s + ":" + r[:s].to_s + " || " + x.to_s)
			Curses::refresh
			sleep 1
			#r[:s] -= 1
			if r[:s] == 0 then
				if r[:m] > 0 then
					r[:m] -= 1
					r[:s] = 60
				elsif r[:m] == 0 and r[:h] > 0 then
					r[:h] -= 1
					r[:m] += 59
					r[:s] = 60
				else
					break
				end
			end
			if r[:m] == 0 then
				if r[:h] > 0 then
					r[:h] -= 1
					r[:m] = 60
				else
					break if r[:s] == 0
				end
			end
			r[:s] -= 1
		end
	end
	protected :cdown

	def timerend()
		Curses::refresh
		Curses::close_screen
	end
end





class ScTimer
	def initialize()
		@count = 0
		@countup = true
		loop do
			print %Q{Which will you use? [count up(up) / count down(down)]: }
			md = STDIN.gets
			if md =~ /up$/ then
				@countup = true
				break
			elsif md =~ /down$/ then
				@countup = false
				break
			else
				print %Q{\nInvailid value entered.\n}
				print %Q{exit? [y/n]: }
				if STDIN.gets =~ /^y/ then
					exit 0
				end
			end
		end
	end

	def setcounter(counts)
		if counts.class == Fixnum  and counts >= 0 then
			@count = counts
		else
			raise(ArgumentError,"Invailid value.")
		end
	end
	public :setcounter

	def countup?()
		return @countup
	end
	public :countup?

	def count()
		ccounter = CursesCounter.new(@countup,@count)
		ccounter.start
		ccounter.timerend
	end
	public :count

end

